using NodePipeline.Abstractions.Attributes;
using NodePipeline.Abstractions.Interfaces.Nodes;
using NodePipeline.Abstractions.Models;
using NodePipeline.Engine.CodeGeneration.Abstractions.Models;

namespace NodePipeline.Engine.Tests.CodeGeneratorTests.Fixtures.MockNodes;

public class OneInputPortSimpleNode : INode
{
    [NodeField(FieldDirection.Input)] public NodeField<int> Input { get; set; } = null!;

    public void Execute()
    {
        throw new NotImplementedException();
    }

    internal static NodeDescriptor GetDescriptor()
    {
        return new NodeDescriptor(nameof(OneInputPortSimpleNode), false, typeof(OneInputPortSimpleNode).FullName!,
            typeof(OneInputPortSimpleNode).FullName!,
            [
                new NodeFieldDescriptor(nameof(Input), nameof(Input), typeof(int).FullName!, false, false, false,
                    FieldDirection.Input, null)
            ], true, null);
    }
}